
// Configure the number of buttons.  Be careful not to use a pin for both a digital button and analog
// axis.  The pullup resistor will interfere with the analog voltage.
const int numButtons = 39;  
void setup() {
  Serial.begin(9600);
  Joystick.useManualSend(true);
  for (int i=0; i<numButtons; i++) {
    pinMode(i, INPUT_PULLUP);
  }
  Serial.println("Begin Complete Joystick Test");
}
byte allButtons[numButtons];
byte prevButtons[numButtons];

void loop() {
//Set up use values
 int joyy = (analogRead(36));
 int joyx = (analogRead(37));
 int joyz = (1023-analogRead(38));
 int joyzr = (1023-analogRead(39));

 //Check Dead Zones and center
 if (joyy > 412 && joyy < 612) {joyy = 512;}
 if (joyx > 412 && joyx < 612) {joyx = 512;}
 if (joyz > 320 && joyz < 680) {joyz = 512;}
 if (joyzr > 412 && joyzr < 612) {joyzr = 512;}

 //set high and lows to extents
 if (joyx < 300) {joyx = 0;}
 if (joyx > 850) {joyx = 1023;}
 if (joyy < 300) {joyy = 0;}
 if (joyy > 850) {joyy = 1023;}
 if (joyz < 200) {joyz = 0;}
 if (joyz > 800) {joyz = 1023;}
 if (joyzr < 200) {joyzr = 0;}
 if (joyzr > 850) {joyzr = 1023;}
 //use values for input
  Joystick.Y(joyy);
  Joystick.X(joyx);
  Joystick.Z(joyz);
  Joystick.Zrotate(joyzr);

 //int val;
 // val = analogRead(37);
//  Serial.println(val);

Joystick.hat(-1);
 if (digitalRead(32)==LOW) { Joystick.hat(0);}
 if (digitalRead(33)==LOW) { Joystick.hat(180);}
 if (digitalRead(34)==LOW) { Joystick.hat(270);}
 if (digitalRead(35)==LOW) { Joystick.hat(90);}
  
    // read digital pins and use them for the buttons
  for (int i=0; i<numButtons; i++) {
    if (digitalRead(i)) {
      // when a pin reads high, the button is not pressed
      // the pullup resistor creates the "on" signal
      allButtons[i] = 0;
    } else {
      // when a pin reads low, the button is connecting to ground.
      allButtons[i] = 1;
    }
    Joystick.button(i + 1, allButtons[i]);
  }
  
  // Because setup configured the Joystick manual send, the computer does not see any of the changes yet.
  // This send_now() transmits everything all at once.
  Joystick.send_now();
  // check to see if any button changed since last time
  boolean anyChange = false;
  for (int i=0; i<numButtons; i++) {
    if (allButtons[i] != prevButtons[i]) anyChange = true;
    prevButtons[i] = allButtons[i];
  }
  
  // if any button changed, print them to the serial monitor
  if (anyChange) {
    Serial.print("Buttons: ");
    for (int i=0; i<numButtons; i++) {
      Serial.print(allButtons[i], DEC);
    }
    Serial.println();
  }
  
  // a brief delay, so this runs "only" 200 times per second
  delay(5);
}

